-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Improved Movement Data v1.4
-- Author: Arstahd
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Create new formation classes
INSERT INTO Types (Type, Kind) VALUES 
		('FORMATION_CLASS_LAND_RANGED', 'KIND_FORMATION_CLASS'),
		('FORMATION_CLASS_LAND_CAVALRY', 'KIND_FORMATION_CLASS'),
		('FORMATION_CLASS_NAVAL_RANGED', 'KIND_FORMATION_CLASS');

INSERT INTO UnitFormationClasses (FormationClassType, Name) VALUES 
		('FORMATION_CLASS_LAND_RANGED', 'LOC_FORMATION_CLASS_LAND_COMBAT_NAME'),
		('FORMATION_CLASS_LAND_CAVALRY', 'LOC_FORMATION_CLASS_LAND_COMBAT_NAME'),
		('FORMATION_CLASS_NAVAL_RANGED', 'LOC_FORMATION_CLASS_NAVAL_NAME');


-- Change Ranged units to Land Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_RANGED' WHERE PromotionClass='PROMOTION_CLASS_RANGED';
-- Change Siege units to Land Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_RANGED' WHERE PromotionClass='PROMOTION_CLASS_SIEGE';
-- Change Recon units to Land Ranged formation type
--UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_RANGED' WHERE PromotionClass='PROMOTION_CLASS_RECON';


-- Change Light Cavalry units to Land Cavalry formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_CAVALRY' WHERE PromotionClass='PROMOTION_CLASS_LIGHT_CAVALRY';
-- Change Heavy Cavalry units to Land Cavalry formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_CAVALRY' WHERE PromotionClass='PROMOTION_CLASS_HEAVY_CAVALRY';


-- Change Naval Ranged units to Naval Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_NAVAL_RANGED' WHERE PromotionClass='PROMOTION_CLASS_NAVAL_RANGED';
-- Change Naval Raider units to Naval Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_NAVAL_RANGED' WHERE PromotionClass='PROMOTION_CLASS_NAVAL_RAIDER';

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Compatibility for "Warfare Expanded: Reloaded"
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Change Automatic Gun units to Land Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_LAND_RANGED' WHERE PromotionClass='PROMOTION_CLASS_AUTOMATIC_GUN';
-- Change Naval Bombard units to Naval Ranged formation type
UPDATE Units SET  FormationClass='FORMATION_CLASS_NAVAL_RANGED' WHERE PromotionClass='PROMOTION_CLASS_NAVAL_BOMBARD';

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------




-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Increase Movement of Land units 
UPDATE Units SET BaseMoves=BaseMoves+1 WHERE Domain='DOMAIN_LAND';
--  Increase Movement of Air units 
UPDATE Units SET BaseMoves=BaseMoves+1 WHERE Domain='DOMAIN_AIR';
--  Increase Movement of Sea units 
UPDATE Units SET BaseMoves=BaseMoves+2 WHERE Domain='DOMAIN_SEA';
--  Increase Movement of Embarked units
UPDATE GlobalParameters SET Value=Value+2 WHERE Name='MOVEMENT_WHILE_EMBARKED_BASE';
--  Reduce Bonus Movement of Embarked units from Steam Tech
UPDATE ModifierArguments SET Value=1 WHERE ModifierId='STEAM_POWER_ADJUST_EMBARKED_MOVEMENT';
--  Increase Movement bonus from Great Admiral
UPDATE UnitAbilityModifiers SET ModifierId='GREAT_ADMIRAL_MOVEMENT' WHERE UnitAbilityType='ABILITY_GREAT_ADMIRAL_MOVEMENT';
UPDATE ModifierArguments SET Value=2 WHERE ModifierId='GREAT_ADMIRAL_MOVEMENT' and Name= 'Amount';
UPDATE Units SET BaseMoves=BaseMoves+2 WHERE UnitType='UNIT_GREAT_ADMIRAL';
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Adjust Movement cost of roads 
--UPDATE Routes SET MovementCost=1.00 WHERE RouteType='ROUTE_ANCIENT_ROAD';
UPDATE Routes SET MovementCost=0.75 WHERE RouteType='ROUTE_MEDIEVAL_ROAD';
UPDATE Routes SET MovementCost=0.60 WHERE RouteType='ROUTE_INDUSTRIAL_ROAD';
--UPDATE Routes SET MovementCost=0.50 WHERE RouteType='ROUTE_MODERN_ROAD';
UPDATE Routes SET MovementCost=0.334 WHERE RouteType='ROUTE_RAILROAD';
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Push Railroads to Combined Arms
CREATE TABLE IF NOT EXISTS Technologies_XP2 (TechnologyType VARCHAR, HiddenUntilPrereqComplete BOOLEAN, RandomPrereqs BOOLEAN);
INSERT INTO Technologies_XP2 (TechnologyType, HiddenUntilPrereqComplete, RandomPrereqs) VALUES ('TECH_COMBINED_ARMS', 0, 0);

CREATE TABLE IF NOT EXISTS Routes_XP2 (RouteType VARCHAR, BuildWithUnitChargeCost INTEGER, BuildOnlyWithUnit BOOLEAN, PrereqTech VARCHAR);
INSERT OR REPLACE INTO Routes_XP2 (RouteType, BuildWithUnitChargeCost, BuildOnlyWithUnit, PrereqTech) VALUES ('ROUTE_RAILROAD', 0, 1, 'TECH_COMBINED_ARMS');
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Increase Railroad Iron cost to 2
CREATE TABLE IF NOT EXISTS Route_ResourceCosts (RouteType VARCHAR, ResourceType VARCHAR, BuildWithUnitCost INTEGER);
INSERT OR REPLACE INTO Route_ResourceCosts (RouteType, ResourceType, BuildWithUnitCost) VALUES ('ROUTE_RAILROAD', 'RESOURCE_IRON', 2);
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------





-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Allow Settlers to build roads
UPDATE Units SET BuildCharges=6 WHERE UnitType='UNIT_SETTLER';

INSERT INTO Route_ValidBuildUnits (RouteType, UnitType) VALUES 
		('ROUTE_ANCIENT_ROAD', 'UNIT_SETTLER'),
		('ROUTE_MEDIEVAL_ROAD', 'UNIT_SETTLER'),
		('ROUTE_INDUSTRIAL_ROAD', 'UNIT_SETTLER'),	
		('ROUTE_MODERN_ROAD', 'UNIT_SETTLER');		

--  Allow Settlers to build railroads
INSERT INTO Route_ValidBuildUnits (RouteType, UnitType) SELECT 'ROUTE_RAILROAD', 'UNIT_SETTLER' WHERE EXISTS (SELECT 1 FROM Routes WHERE RouteType = 'ROUTE_RAILROAD');
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--  Add boost to Settler build charges to The Wheel
INSERT INTO Modifiers (ModifierId, ModifierType, SubjectRequirementSetId) VALUES ('TECH_ADD_SETTLER_CHARGES', 'MODIFIER_PLAYER_UNITS_ADJUST_BUILDER_CHARGES', 'UNIT_IS_SETTLER');

INSERT INTO ModifierArguments (ModifierId, Name, Value) VALUES ('TECH_ADD_SETTLER_CHARGES', 'Amount', 6 );

INSERT INTO TechnologyModifiers (TechnologyType, ModifierId) VALUES ('TECH_THE_WHEEL', 'TECH_ADD_SETTLER_CHARGES');


--  Create Settler requirement
INSERT INTO RequirementSets (RequirementSetId, RequirementSetType) VALUES ('UNIT_IS_SETTLER', 'REQUIREMENTSET_TEST_ALL');

INSERT INTO RequirementSetRequirements (RequirementSetId, RequirementId) VALUES ('UNIT_IS_SETTLER', 'REQUIREMENT_UNIT_IS_SETTLER');

INSERT INTO Requirements (RequirementId, RequirementType, Inverse) VALUES ('REQUIREMENT_UNIT_IS_SETTLER', 'REQUIREMENT_UNIT_TYPE_MATCHES', 0);

INSERT INTO RequirementArguments (RequirementId, Name, Value) VALUES ('REQUIREMENT_UNIT_IS_SETTLER', 'UnitType', 'UNIT_SETTLER');

--  Add Info Star to The Wheel
UPDATE Technologies SET Description='LOC_TECH_THE_WHEEL_DESCRIPTION' WHERE TechnologyType='TECH_THE_WHEEL' ;
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------





-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
